#version 450

layout(binding = 0) uniform usampler2D texture_region_id_previous;//id_2
layout(binding = 1) uniform sampler2D texture_region_color_ini;

in smooth vec2 pos;
in smooth vec4 color_in_1;
in smooth vec4 color_in_2;
in flat ivec2 id;
in flat int reverse;

layout(location = 0) out int id_out_1;//id_1   // it is merged
layout(location = 1) out int id_out_2;//id_2   // it is not merged
layout(location = 2) out vec4 error_map_;
layout(location = 3) out vec4 color_out;

void main(void)
{
	if(texture(texture_region_id_previous, pos).r != id.x && texture(texture_region_id_previous, pos).r != id.y)
		discard;
	if(reverse == 1)
	{
		if(texture(texture_region_id_previous, pos).r == id.y)
		{
			id_out_1 = id.y;
			color_out = color_in_2;
		}
		else
		{
			id_out_1 = id.x;
			color_out = color_in_1;
		}
	}
	else
	{
		id_out_1 = id.x;
		color_out = color_in_1;
		//id_out_1 = id.x;
	}
	error_map_.r = distance(color_out, texture(texture_region_color_ini, pos));
	error_map_.b = 1.0f - error_map_.r;
	error_map_.g = 0.0f;
	error_map_.a = 1.0f;
	id_out_2 = id_out_1;
}
