#version 450

layout(points) in;
layout(triangle_strip, max_vertices=4) out;
struct BaseRegionData{
	mat2x4 g;	
	mat2x4 g_ini;	
	vec4 c1;
	vec4 c1_ini;	
	vec4 c2;
	vec4 error;	
	vec4 last_bbox;//put last p1 p2 to unmerge. to split we wille compute in cuda computing the sum of errors
	vec4 ini_bbox;	
	vec2 p1;
	vec2 p2;
	vec2 p;
	vec2 p_ini;
	int id;
	int n;
	int n_ini;
	int padding_int;
	vec4 padding_vec4;
};
layout(binding = 2, std140) buffer Region_data
{
	BaseRegionData[] r;
}region_data;

in flat ivec2 idt[];

out smooth vec2 pos;
out smooth vec4 color_in_1;
out smooth vec4 color_in_2;
out flat ivec2 id;
out flat int reverse;
void main()
{
	BaseRegionData brd1 = region_data.r[idt[0].x];
	BaseRegionData brd2 = region_data.r[idt[0].y];
	vec2 tex[2];
	tex[0] = brd1.p1;
	tex[1] = brd1.p2;
	int local_reverse = brd1.error.a>=0.00f ? 1 : 0;
	
	
	//local_reverse = 0;
	
	
	
	if(local_reverse == 1)//dans delta error, we substract T * log(rand([0, 1]))
	{
	//fit new gradient
		int n1 = brd1.n;
		brd1.n = n1 - brd2.n;
		float inv_sum = 1.0 / float(n1);
		float inv_s1 = 1.0f / (float(brd1.n) * inv_sum);
		float s2 = float(brd2.n) * inv_sum;
		
		//brd1.g  = brd1.g  * s1 + brd2.g  * s2;
		brd1.g = (brd1.g - brd2.g * s2) * inv_s1;
		brd1.p = (brd1.p - brd2.p * s2) * inv_s1;
		brd1.c1 = (brd1.c1 - brd2.c1 * s2) * inv_s1;
		
		brd1.error.r = brd1.error.b;
	//	brd1.error.b = brd1.error.r;
	//	brd1.error.g = brd1.error.r * s1 + brd2.error.r * s2;
		
		brd1.c2 = brd1.c1 - brd1.g * brd1.p;
		
		brd1.p1 = brd1.last_bbox.xy;
		brd1.p2 = brd1.last_bbox.zw;
		
		region_data.r[idt[0].x] = brd1;
	}
//send a square to fragment shader to update texture id
	vec2 pos_[2];
	pos_[0] = tex[0]*2.0f - 1.0f;
	pos_[1] = tex[1]*2.0f - 1.0f;
	
	gl_Position = vec4(pos_[0].x, pos_[0].y,1.0f,1.0f);
	pos = tex[0];
	//color_in = vec4(brd1.g * pos + brd1.c2,1.0f);
	color_in_1 = brd1.g * pos + brd1.c2;
	color_in_2 = brd2.g * pos + brd2.c2;
	id = idt[0];
	reverse = local_reverse;
    EmitVertex();
	gl_Position = vec4(pos_[1].x, pos_[0].y,1.0f,1.0f);
	pos = vec2(tex[1].x, tex[0].y);
	color_in_1 = brd1.g * pos + brd1.c2;
	color_in_2 = brd2.g * pos + brd2.c2;
	id = idt[0];
	reverse = local_reverse;
    EmitVertex();
	gl_Position = vec4(pos_[0].x, pos_[1].y,1.0f,1.0f);
	pos = vec2(tex[0].x, tex[1].y);
	color_in_1 = brd1.g * pos + brd1.c2;
	color_in_2 = brd2.g * pos + brd2.c2;
	id = idt[0];
	reverse = local_reverse;
    EmitVertex();
	gl_Position = vec4(pos_[1].x, pos_[1].y,1.0f,1.0f);
	pos = tex[1];
	color_in_1 = brd1.g * pos + brd1.c2;
	color_in_2 = brd2.g * pos + brd2.c2;
	id = idt[0];
	reverse = local_reverse;
    EmitVertex();
    EndPrimitive();
}