#version 450




layout(binding = 0) uniform usampler2D texture_region_id_ini;
layout(binding = 1) uniform sampler2D texture_region_color_ini;

in smooth vec2 pos;
in smooth vec4 color_in;
in flat ivec2 id;

layout(location = 0) out int id_out;//id_1
layout(location = 1) out vec4 error_map;
layout(location = 2) out vec4 color_out;;

void main(void)
{
	if(texture(texture_region_id_ini, pos).r != id.x)
		discard;
		
	//update texture id
	id_out = id.y;
	//update texture color
	color_out = color_in;
	error_map.r = distance(color_in, texture(texture_region_color_ini, pos));
	error_map.b = 1.0f - error_map.r;
	error_map.g = 0.0f;
	error_map.a = 1.0f;
}
