#version 450

layout(points) in;
layout(triangle_strip, max_vertices=4) out;
struct BaseRegionData{
	mat2x4 g;	
	mat2x4 g_ini;	
	vec4 c1;
	vec4 c1_ini;	
	vec4 c2;
	vec4 error;	
	vec4 last_bbox;//put last p1 p2 to unmerge. to split we wille compute in cuda computing the sum of errors
	vec4 ini_bbox;	
	vec2 p1;
	vec2 p2;
	vec2 p;
	vec2 p_ini;	
	int id;
	int n;
	int n_ini;
	int padding_int;
	vec4 padding_vec4;
};
layout(binding = 2, std140) buffer Region_data
{
	BaseRegionData[] r;
}region_data;

in flat int idt[];

out smooth vec2 pos;
out smooth vec4 color_in;
out flat int id;

void main()
{
	BaseRegionData brd1 = region_data.r[idt[0].x];
	

//send a square to fragment shader to update texture id
	vec2 pos_[2];
	vec2 tex[2];
	tex[0] = brd1.p1;
	tex[1] = brd1.p2;
	pos_[0] = tex[0]*2.0f - 1.0f;
	pos_[1] = tex[1]*2.0f - 1.0f;
	
	gl_Position = vec4(pos_[0].x, pos_[0].y,1.0f,1.0f);
	pos = tex[0];
	//color_in = vec4(brd1.g * pos + brd1.c2,1.0f);
	color_in = brd1.g * pos + brd1.c2;
	id = idt[0];
    EmitVertex();
	gl_Position = vec4(pos_[1].x, pos_[0].y,1.0f,1.0f);
	pos = vec2(tex[1].x, tex[0].y);
	color_in = brd1.g * pos + brd1.c2;
	id = idt[0];
    EmitVertex();
	gl_Position = vec4(pos_[0].x, pos_[1].y,1.0f,1.0f);
	pos = vec2(tex[0].x, tex[1].y);
	color_in = brd1.g * pos + brd1.c2;
	id = idt[0];
    EmitVertex();
	gl_Position = vec4(pos_[1].x, pos_[1].y,1.0f,1.0f);
	pos = tex[1];
	color_in = brd1.g * pos + brd1.c2;
	id = idt[0];
    EmitVertex();
    EndPrimitive();
}