#version 330

//uniform int g_Detail;

layout(triangles) in;
layout(line_strip, max_vertices=32) out;
uniform float depth;

in _p2{
    vec2 p2;
} gs_in[];

 vec2 evaluateBezierPosition(vec2 pos[3], float t )
{
    float unmt = 1.0 - t;
    float t2 = t*t;
    float b0 = unmt*unmt;
    float b1 = 2*(t-t2);
    float b2 = t2;
	return b0*pos[0] + b1*pos[1] + b2*pos[2];
}
void main()
{
vec2 pos[3];
  pos[0] = gs_in[0].p2;
  pos[1] = gs_in[1].p2;
  pos[2] = gs_in[2].p2;
  float OneOverDetail = 1.0 / 31;
  for( int i=0; i<32; i++ )
  {
      float t = i * OneOverDetail;
      vec2 p = evaluateBezierPosition(pos, t );
      gl_Position = vec4( p, depth, 1.0 );
      EmitVertex();
      //vec4 p = evaluateBezierPosition(pos, t );
      //gl_Position = vec4( p.xy + p.wz*0.005f, depth, 1.0 );
      //EmitVertex();
      //gl_Position = vec4( p.xy - p.wz*0.005f, depth, 1.0 );
      //EmitVertex();
  }
    EndPrimitive();
}